Bug 1410007 - Review Request: mraa - A low level skeleton library for Industrial IO Communication
Summary: Review Request: mraa - A low level skeleton library for Industrial IO Communi...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jared Smith
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: IoT
TreeView+ depends on / blocked
 
Reported: 2017-01-04 07:49 UTC by Peter Robinson
Modified: 2017-04-25 13:18 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-04-25 13:18:59 UTC
Type: Bug
jsmith.fedora: fedora-review+


Attachments (Terms of Use)

Description Peter Robinson 2017-01-04 07:49:46 UTC
SPEC: https://pbrobinson.fedorapeople.org/mraa.spec
SRPM: https://pbrobinson.fedorapeople.org/mraa-1.5.1-1.fc25.src.rpm

Description:
mraa is a low level skeleton library for Industrial IO Communication and 
includes python, java and Node-JS bindings.

koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=17160698

Comment 1 Jared Smith 2017-01-05 01:20:14 UTC
I'm taking on the review of this package.

Comment 2 Jared Smith 2017-01-05 01:58:43 UTC
Please review the issues below:

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- License seems to disagree with output of licensecheck
- Packages do not install properly (mraa-devel has a dependency on /bin/usr/env,
  which seems obviously wrong)
- License file isn't installed w/ certain subpackages
- Package doesn't own all of the directories it creates
- Sub-packages should have fully-versioned dependency
- Many js and python scripts without proper shebang


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[!]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "*No copyright* BSL", "Unknown or generated",
     "*No copyright* LGPL (v2.1)", "MIT/X11 (BSD like)", "BSL (v1.0)", "*No
     copyright* BSD (3 clause)", "BSD (3 clause)". 104 files have unknown
     license. Detailed output of licensecheck in
     /home/jsmith/Documents/Personal/Reviews/1410007-mraa/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/libexec/mraa
[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib64/python3.6/site-
     packages/__pycache__(system-python-libs, audit-libs-python3)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mraa-
     debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.3.3 starting (python version = 3.6.0)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
Mock Version: 1.3.3
INFO: Mock Version: 1.3.3
Finish: chroot init
INFO: installing package(s): /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/nodejs-mraa-1.5.1-1.fc26.x86_64.rpm /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/mraa-1.5.1-1.fc26.x86_64.rpm /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/mraa-devel-1.5.1-1.fc26.x86_64.rpm /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/python3-iio-1.5.1-1.fc26.x86_64.rpm /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/mraa-debuginfo-1.5.1-1.fc26.x86_64.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 26 --disableplugin=local --setopt=deltarpm=false install /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/nodejs-mraa-1.5.1-1.fc26.x86_64.rpm /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/mraa-1.5.1-1.fc26.x86_64.rpm /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/mraa-devel-1.5.1-1.fc26.x86_64.rpm /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/python3-iio-1.5.1-1.fc26.x86_64.rpm /home/jsmith/Documents/Personal/Reviews/1410007-mraa/results/mraa-debuginfo-1.5.1-1.fc26.x86_64.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: mraa-1.5.1-1.fc26.x86_64.rpm
          mraa-devel-1.5.1-1.fc26.x86_64.rpm
          python3-iio-1.5.1-1.fc26.x86_64.rpm
          nodejs-mraa-1.5.1-1.fc26.x86_64.rpm
          mraa-debuginfo-1.5.1-1.fc26.x86_64.rpm
          mraa-1.5.1-1.fc26.src.rpm
mraa.x86_64: W: no-manual-page-for-binary mraa-gpio
mraa.x86_64: W: no-manual-page-for-binary mraa-i2c
mraa-devel.x86_64: W: only-non-binary-in-usr-lib
mraa-devel.x86_64: W: no-documentation
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/AioA0.js
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/Blink-IO.js
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/GPIO_DigitalRead.js
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/GPIO_DigitalWrite.js
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/javascript/bmp85.js /usr/bin/env node
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/firmata.js
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/gpio-tool.js
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/initio.js
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/javascript/isr.js /usr/bin/env node
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/rgblcd.js
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/javascript/spi.js /usr/bin/env node
mraa-devel.x86_64: E: script-without-shebang /usr/libexec/mraa/examples/javascript/uart.js
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/aio.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/blink-io8.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/bmp85.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/cycle-pwm3.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/firmata.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/hello_gpio.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/hello_isr.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/initio.py /bin/usr/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/rgblcd.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/spi.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/uart_receiver.py /usr/bin/env python
mraa-devel.x86_64: E: wrong-script-interpreter /usr/libexec/mraa/examples/python/uart_sender.py /usr/bin/env python
python3-iio.x86_64: W: no-documentation
nodejs-mraa.x86_64: W: no-documentation
6 packages and 0 specfiles checked; 24 errors, 6 warnings.




Requires
--------
python3-iio (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libmraa.so.1()(64bit)
    libpthread.so.0()(64bit)
    libpython3.6m.so.1.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    mraa(x86-64)
    python(abi)
    rtld(GNU_HASH)

mraa-debuginfo (rpmlib, GLIBC filtered):

mraa-devel (rpmlib, GLIBC filtered):
    /bin/usr/env
    /usr/bin/env
    /usr/bin/pkg-config
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libmraa.so.1()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    mraa(x86-64)
    rtld(GNU_HASH)

nodejs-mraa (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libmraa.so.1()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    mraa(x86-64)
    nodejs(abi6)
    nodejs(engine)
    nodejs(v8-abi5)
    rtld(GNU_HASH)

mraa (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libmraa.so.1()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)



Provides
--------
python3-iio:
    python3-iio
    python3-iio(x86-64)

mraa-debuginfo:
    mraa-debuginfo
    mraa-debuginfo(x86-64)

mraa-devel:
    mraa-devel
    mraa-devel(x86-64)
    pkgconfig(mraa)

nodejs-mraa:
    nodejs-mraa
    nodejs-mraa(x86-64)
    npm(mraa)

mraa:
    libmraa.so.1()(64bit)
    mraa
    mraa(x86-64)



Unversioned so-files
--------------------
python3-iio: /usr/lib64/python3.6/site-packages/_mraa.so

Source checksums
----------------
https://github.com/intel-iot-devkit/mraa/archive/v1.5.1.tar.gz :
  CHECKSUM(SHA256) this package     : f76eb1df538b4058f7b085b3529e1f350f68a2aa8ed1766ed951098666b9d9a8
  CHECKSUM(SHA256) upstream package : f76eb1df538b4058f7b085b3529e1f350f68a2aa8ed1766ed951098666b9d9a8


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1410007
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Peter Robinson 2017-01-09 09:28:37 UTC
> Issues:
> =======
> - License seems to disagree with output of licensecheck

See below

> - Packages do not install properly (mraa-devel has a dependency on
> /bin/usr/env,
>   which seems obviously wrong)

It seems to come from some of the examples (see rpmlint output) so I'm not sure it is wrong. Suggestions?

> - License file isn't installed w/ certain subpackages

Not sure which ones, all sub packages have a dependency on "Requires: %{name}%{?_isa} = %{version}-%{release}" which will bring in the license file.

> - Package doesn't own all of the directories it creates
> - Sub-packages should have fully-versioned dependency

They all depend on "Requires: %{name}%{?_isa} = %{version}-%{release}" which I believe to be correct. Can you be more specific.

> - Many js and python scripts without proper shebang

I'll report that upstream.

> [!]: Development (unversioned) .so files in -devel subpackage, if present.
>      Note: Unversioned so-files in private %_libdir subdirectory (see
>      attachment). Verify they are not in ld path.

> [!]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses
>      found: "Apache (v2.0)", "*No copyright* BSL", "Unknown or generated",
>      "*No copyright* LGPL (v2.1)", "MIT/X11 (BSD like)", "BSL (v1.0)", "*No
>      copyright* BSD (3 clause)", "BSD (3 clause)". 104 files have unknown
>      license. Detailed output of licensecheck in
>      /home/jsmith/Documents/Personal/Reviews/1410007-mraa/licensecheck.txt

The COPYING file states it's MIT so I've updates it to that. 

> [!]: License file installed when any subpackage combination is installed.

See note above.

> [!]: Package must own all directories that it creates.
>      Note: Directories without known owners: /usr/libexec/mraa

Fixed.

> [!]: Package does not own files or directories owned by other packages.
>      Note: Dirs in package are owned also by: /usr/lib64/python3.6/site-
>      packages/__pycache__(system-python-libs, audit-libs-python3)

I don't see the issue there

> [!]: Final provides and requires are sane (see attachments).
> [!]: Fully versioned dependency in subpackages if applicable.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mraa-
>      debuginfo

debuginfo is a automatically generated package. I don't see this is a packaging problem.

SPEC: as above
SRPM: https://pbrobinson.fedorapeople.org/mraa-1.5.1-2.fc25.src.rpm

Comment 4 Jared Smith 2017-02-15 21:49:20 UTC
(In reply to Peter Robinson from comment #3)
> > - Packages do not install properly (mraa-devel has a dependency on
> > /bin/usr/env,
> >   which seems obviously wrong)
> 
> It seems to come from some of the examples (see rpmlint output) so I'm not
> sure it is wrong. Suggestions?

It comes from examples/python/initio.py, which has an obviously wrong shebang line.  I'd just patch that file :-)


> > - Many js and python scripts without proper shebang
> 
> I'll report that upstream.

Besides that, you may just use sed to replace "bin/env " with "bin/" on the first line of those files.

Other than these two outstanding issues, I'm ready to move forward with the package approval.

Comment 7 Jared Smith 2017-04-25 10:38:54 UTC
Approved.

Comment 8 Gwyn Ciesla 2017-04-25 12:16:05 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/mraa


Note You need to log in before you can comment on or make changes to this bug.